searchNodes=[{"doc":"LanguageColours offers an API for retrieving colours for programming languages based on GitHub colour data (or some other dataset). iex&gt; LanguageColours . get ( &quot;Ada&quot; , :my_db ) &quot;#02f88c&quot; To install, add LanguageColours as a dependency of your Mix project: defp deps do [ { :language_colours , &quot;~&gt; 1.0.0&quot; } , ... ] end Databases LanguageColours can be served by different databases. Databases must conform to the LanguageColours.Database behaviour. There is one database included, the LanguageColours.ETSDatabase , that uses ETS to store the language colour data. As a source, it uses a JSON file in the format found in the https://github.com/ozh/github-colors/ repo. This file can be downloaded in a development environment with mix language.colours.dl.data . Fallback colours If a language is not found in the database, nil will be returned by default. Optionally, the Rainbow package can be used to generate a random colour based on the language name as fallback. To use the fallback, set the database configuration option :fallback to true , and install Rainbow as a dependency: defp deps do [ { :rainbow , &quot;~&gt; 0.1.0&quot; } , ... ] end Configuration To configure a database, you can give the configuration directly in the function call: config = %{ ... } LanguageColours . get ( &quot;C++&quot; , config ) Or you can configure database aliases in your favourite config file ( runtime.exs is recommended so you don't need to recompile the app on config changes): # Config file config :language_colours , databases : %{ foo_db : %{ ... } } Then you can use this name in the function call: LanguageColours . get ( &quot;COBOL&quot; , :foo_db ) The supported configuration options are: :json_parser : Module name of the JSON parser to use. Default is Jason . :databases : An atom-keyed map of database specific configurations, which can be maps themselves or keyword lists. The database specific configuration options are: :db : The database module to use. This option is required. :fallback : Boolean specifying whether to get a fallback colour from Rainbow or not, if language was not found in database. Default false . Additionally, the ETSDatabase has its own database specific options: :file : Path to the file to read the JSON data from. :server_name : The name to use for the database process. Must conform to GenServer.name/0 . By default the module name is used. :ets_table : Name of the ETS table to use. Setting up using ETSDatabase First configure your database. Then start the database in your supervisor using the LanguageColours.ETSDatabase.startup_options/1 function like this: config = LanguageColours . config! ( :foo_db ) children = [ ... , { LanguageColours.ETSDatabase , LanguageColours.ETSDatabase . startup_options ( config ) } , ... ] Alternatively you can directly give the LanguageColours.ETSDatabase.Options.t/0 struct as the argument.","ref":"LanguageColours.html","title":"LanguageColours","type":"module"},{"doc":"Retrieve the configuration for the given database name. If the database is not configured, an error will be raised.","ref":"LanguageColours.html#config!/1","title":"LanguageColours.config!/1","type":"function"},{"doc":"Get the colour corresponding to the given language. The database specified in the second argument (as configuration or preconfigured database name) is used to fetch the language. If the language is not found and fallback is not configured, nil is returned.","ref":"LanguageColours.html#get/2","title":"LanguageColours.get/2","type":"function"},{"doc":"Update the database specified in the argument. The argument may be a preconfigured database name or a configuration map/kwlist.","ref":"LanguageColours.html#update/1","title":"LanguageColours.update/1","type":"function"},{"doc":"","ref":"LanguageColours.Colour.html","title":"LanguageColours.Colour","type":"module"},{"doc":"A colour returned by the API, a hex colour of six characters with a hash prepended.","ref":"LanguageColours.Colour.html#t:t/0","title":"LanguageColours.Colour.t/0","type":"type"},{"doc":"Behaviour that must be implemented by a database. Each function gets a database configuration as argument. This configuration should be used to talk to the correct database instance. It is not necessary to deal with the fallback as the main module handles that.","ref":"LanguageColours.Database.html","title":"LanguageColours.Database","type":"behaviour"},{"doc":"Get a colour for the given language, or nil .","ref":"LanguageColours.Database.html#c:get/2","title":"LanguageColours.Database.get/2","type":"callback"},{"doc":"Update the language dataset using the configuration.","ref":"LanguageColours.Database.html#c:update/1","title":"LanguageColours.Database.update/1","type":"callback"},{"doc":"Database that stores the language colours in an ETS table. Get operations will directly read from the database, update operations will be serialized through the database process. Please see the main module documentation for the available configuration options and how to set up the database.","ref":"LanguageColours.ETSDatabase.html","title":"LanguageColours.ETSDatabase","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LanguageColours.ETSDatabase.html#child_spec/1","title":"LanguageColours.ETSDatabase.child_spec/1","type":"function"},{"doc":"","ref":"LanguageColours.ETSDatabase.html#start_link/1","title":"LanguageColours.ETSDatabase.start_link/1","type":"function"},{"doc":"Get an LanguageColours.ETSDatabase.Options.t/0 struct corresponding to the given database configuration. This is a helper for forming the options struct for starting the database in a supervisor. NOTE: When using this function, the :file option is required.","ref":"LanguageColours.ETSDatabase.html#startup_options/1","title":"LanguageColours.ETSDatabase.startup_options/1","type":"function"},{"doc":"","ref":"LanguageColours.ETSDatabase.Options.html","title":"LanguageColours.ETSDatabase.Options","type":"module"},{"doc":"Options to give to the LanguageColours.ETSDatabase.start_link/1 function. :server_opts : Any options to give to GenServer.start_link/3 . :file : The file to read JSON data from. :ets_table : Name of the ETS table to store the data in.","ref":"LanguageColours.ETSDatabase.Options.html#t:t/0","title":"LanguageColours.ETSDatabase.Options.t/0","type":"type"},{"doc":"Download the GitHub colours JSON dataset (or any other specified dataset). NOTE : This function does not check the HTTPS certificate! Check the file after downloading and only use this task as a helper during development. You can specify the download URL and file path to put the download to with flags: mix language.colours.dl.data --url &#39;https://raw.githubusercontent.com/ozh/github-colors/master/colors.json&#39; --path &#39;priv/language_colours/data.json&#39; The directories leading to the output file will be created if necessary.","ref":"Mix.Tasks.Language.Colours.Dl.Data.html","title":"Mix.Tasks.Language.Colours.Dl.Data","type":"task"}]